package lightcontainer.protocol.rules.writer;

import lightcontainer.protocol.ProtocolWriter;
import lightcontainer.utils.FileReceiver;
import lightcontainer.utils.FileSender;

import java.io.OutputStream;

public class SendfileRule extends ProtocolWriter {

    private static final String PATTERN = "^SENDFILE [A-Za-z0-9.]{0,200} [0-9]{1,10} [A-Za-z0-9.]{50,200}\r\n$";

    public static final String NAME = "SENDFILE";

    private static final int HASHED_FILE_NAME = 0; // Index file name hashed.
    private static final int FILE_SIZE = 1; // Index file size.
    private static final int HASHED_FILE_CONTENT = 2; // Index file content hashed.

    public SendfileRule() {
        super(NAME, PATTERN);
    }

    public class Result extends ProtocolWriter.ProtocolResult {

        private final String hashedFileName;
        private final int fileSize;
        private final String hashedFileContent;

        public Result(String hashedFileName, int fileSize, String hashedFileContent) {
            this.hashedFileName = hashedFileName;
            this.fileSize = fileSize;
            this.hashedFileContent = hashedFileContent;
        }

        @Override
        public void write(OutputStream writer) {
            super.write(writer);
            System.out.println("Envoie du fichier au SBE");
            FileSender fileSender = new FileSender("/home/benjamin/ffe");
            fileSender.sendFile(hashedFileName, writer);
        }
    }


    @Override
    protected SendfileRule.Result onExecuted(String... data) {
        return new SendfileRule.Result(data[HASHED_FILE_NAME], Integer.parseInt(data[FILE_SIZE]), data[HASHED_FILE_CONTENT]);
    }
}
